/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_PatientOrientation;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_PatientOrientation;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;

/**
 * This class represents PatientOrientation CID19
 */
public class PatientOrientation_CID19 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new PatientOrientation_CID19 Template 
	 */
	public PatientOrientation_CID19()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumPatientOrientation Object of EnumCM_PatientOrientation represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_PatientOrientation enumPatientOrientation)
	{
		switch(enumPatientOrientation) 
		{
		case ERECT: this.strCodeValue =EnumCV_PatientOrientation.ERECT_F_10440.getValue(); break;
		case RECUMBENT: this.strCodeValue =EnumCV_PatientOrientation.RECUMBENT_F_10450.getValue(); break;
		case SEMI_ERECT: this.strCodeValue =EnumCV_PatientOrientation.SEMI_ERECT_F_10460.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumPatientOrientation Object of EnumCM_PatientOrientation represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_PatientOrientation enumPatientOrientation)
	{
		switch(enumPatientOrientation)
		{
		case ERECT : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.ERECT.getSNOMEDCTID(); break;
		case RECUMBENT : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.RECUMBENT.getSNOMEDCTID(); break;
		case SEMI_ERECT : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.SEMI_ERECT.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for PatientOrientation
	 * @param enumPatientOrientation Object of EnumCM_PatientOrientation.
	 */
	public void setPatientOrientation(EnumCM_PatientOrientation enumPatientOrientation)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumPatientOrientation.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumPatientOrientation);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumPatientOrientation);
	}
}
